Make test number unique
[git/dscho.git] / git-stash.sh
blob0a9403653d7dbbb6927973dcfcc41bfd9a904e05
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
11 or: $dashless clear"
13 SUBDIRECTORY_OK=Yes
14 OPTIONS_SPEC=
15 START_DIR=`pwd`
16 . git-sh-setup
17 require_work_tree
18 cd_to_toplevel
20 TMP="$GIT_DIR/.git-stash.$$"
21 TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
22 trap 'rm -f "$TMP-"* "$TMPindex"' 0
24 ref_stash=refs/stash
26 if git config --get-colorbool color.interactive; then
27 help_color="$(git config --get-color color.interactive.help 'red bold')"
28 reset_color="$(git config --get-color '' reset)"
29 else
30 help_color=
31 reset_color=
34 no_changes () {
35 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
36 git diff-files --quiet --ignore-submodules
39 clear_stash () {
40 if test $# != 0
41 then
42 die "git stash clear with parameters is unimplemented"
44 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
45 then
46 git update-ref -d $ref_stash $current
50 create_stash () {
51 stash_msg="$1"
53 git update-index -q --refresh
54 if no_changes
55 then
56 exit 0
59 # state of the base commit
60 if b_commit=$(git rev-parse --verify HEAD)
61 then
62 head=$(git rev-list --oneline -n 1 HEAD --)
63 else
64 die "You do not have the initial commit yet"
67 if branch=$(git symbolic-ref -q HEAD)
68 then
69 branch=${branch#refs/heads/}
70 else
71 branch='(no branch)'
73 msg=$(printf '%s: %s' "$branch" "$head")
75 # state of the index
76 i_tree=$(git write-tree) &&
77 i_commit=$(printf 'index on %s\n' "$msg" |
78 git commit-tree $i_tree -p $b_commit) ||
79 die "Cannot save the current index state"
81 if test -z "$patch_mode"
82 then
84 # state of the working tree
85 w_tree=$( (
86 git read-tree --index-output="$TMPindex" -m $i_tree &&
87 GIT_INDEX_FILE="$TMPindex" &&
88 export GIT_INDEX_FILE &&
89 git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
90 git write-tree &&
91 rm -f "$TMPindex"
92 ) ) ||
93 die "Cannot save the current worktree state"
95 else
97 rm -f "$TMP-index" &&
98 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
100 # find out what the user wants
101 GIT_INDEX_FILE="$TMP-index" \
102 git add--interactive --patch=stash -- &&
104 # state of the working tree
105 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
106 die "Cannot save the current worktree state"
108 git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
109 test -s "$TMP-patch" ||
110 die "No changes selected"
112 rm -f "$TMP-index" ||
113 die "Cannot remove temporary index (can't happen)"
117 # create the stash
118 if test -z "$stash_msg"
119 then
120 stash_msg=$(printf 'WIP on %s' "$msg")
121 else
122 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
124 w_commit=$(printf '%s\n' "$stash_msg" |
125 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
126 die "Cannot record working tree state"
129 save_stash () {
130 keep_index=
131 patch_mode=
132 while test $# != 0
134 case "$1" in
135 -k|--keep-index)
136 keep_index=t
138 --no-keep-index)
139 keep_index=n
141 -p|--patch)
142 patch_mode=t
143 # only default to keep if we don't already have an override
144 test -z "$keep_index" && keep_index=t
146 -q|--quiet)
147 GIT_QUIET=t
150 shift
151 break
154 echo "error: unknown option for 'stash save': $1"
155 echo " To provide a message, use git stash save -- '$1'"
156 usage
159 break
161 esac
162 shift
163 done
165 stash_msg="$*"
167 git update-index -q --refresh
168 if no_changes
169 then
170 say 'No local changes to save'
171 exit 0
173 test -f "$GIT_DIR/logs/$ref_stash" ||
174 clear_stash || die "Cannot initialize stash"
176 create_stash "$stash_msg"
178 # Make sure the reflog for stash is kept.
179 : >>"$GIT_DIR/logs/$ref_stash"
181 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
182 die "Cannot save the current status"
183 say Saved working directory and index state "$stash_msg"
185 if test -z "$patch_mode"
186 then
187 git reset --hard ${GIT_QUIET:+-q}
189 if test "$keep_index" = "t" && test -n $i_tree
190 then
191 git read-tree --reset -u $i_tree
193 else
194 git apply -R < "$TMP-patch" ||
195 die "Cannot remove worktree changes"
197 if test "$keep_index" != "t"
198 then
199 git reset
204 have_stash () {
205 git rev-parse --verify $ref_stash >/dev/null 2>&1
208 list_stash () {
209 have_stash || return 0
210 git log --format="%gd: %gs" -g "$@" $ref_stash --
213 show_stash () {
214 assert_stash_like "$@"
216 git diff ${FLAGS:---stat} $b_commit $w_commit
220 # Parses the remaining options looking for flags and
221 # at most one revision defaulting to ${ref_stash}@{0}
222 # if none found.
224 # Derives related tree and commit objects from the
225 # revision, if one is found.
227 # stash records the work tree, and is a merge between the
228 # base commit (first parent) and the index tree (second parent).
230 # REV is set to the symbolic version of the specified stash-like commit
231 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
232 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
233 # s is set to the SHA1 of the stash commit
234 # w_commit is set to the commit containing the working tree
235 # b_commit is set to the base commit
236 # i_commit is set to the commit containing the index tree
237 # w_tree is set to the working tree
238 # b_tree is set to the base tree
239 # i_tree is set to the index tree
241 # GIT_QUIET is set to t if -q is specified
242 # INDEX_OPTION is set to --index if --index is specified.
243 # FLAGS is set to the remaining flags
245 # dies if:
246 # * too many revisions specified
247 # * no revision is specified and there is no stash stack
248 # * a revision is specified which cannot be resolve to a SHA1
249 # * a non-existent stash reference is specified
252 parse_flags_and_rev()
254 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
255 PARSE_CACHE="$*"
257 IS_STASH_LIKE=
258 IS_STASH_REF=
259 INDEX_OPTION=
261 w_commit=
262 b_commit=
263 i_commit=
264 w_tree=
265 b_tree=
266 i_tree=
268 REV=$(git rev-parse --no-flags --symbolic "$@") || exit 1
270 FLAGS=
271 for opt
273 case "$opt" in
274 -q|--quiet)
275 GIT_QUIET=-t
277 --index)
278 INDEX_OPTION=--index
281 FLAGS="${FLAGS}${FLAGS:+ }$opt"
283 esac
284 done
286 set -- $REV
288 case $# in
290 have_stash || die "No stash found."
291 set -- ${ref_stash}@{0}
297 die "Too many revisions specified: $REV"
299 esac
301 REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"
303 i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
304 set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
305 s=$1 &&
306 w_commit=$1 &&
307 b_commit=$2 &&
308 w_tree=$3 &&
309 b_tree=$4 &&
310 i_tree=$5 &&
311 IS_STASH_LIKE=t &&
312 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
313 IS_STASH_REF=t
316 is_stash_like()
318 parse_flags_and_rev "$@"
319 test -n "$IS_STASH_LIKE"
322 assert_stash_like() {
323 is_stash_like "$@" || die "'$*' is not a stash-like commit"
326 is_stash_ref() {
327 is_stash_like "$@" && test -n "$IS_STASH_REF"
330 assert_stash_ref() {
331 is_stash_ref "$@" || die "'$*' is not a stash reference"
334 apply_stash () {
336 assert_stash_like "$@"
338 git update-index -q --refresh || die 'unable to refresh index'
340 # current index state
341 c_tree=$(git write-tree) ||
342 die 'Cannot apply a stash in the middle of a merge'
344 unstashed_index_tree=
345 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
346 test "$c_tree" != "$i_tree"
347 then
348 git diff-tree --binary $s^2^..$s^2 | git apply --cached
349 test $? -ne 0 &&
350 die 'Conflicts in index. Try without --index.'
351 unstashed_index_tree=$(git write-tree) ||
352 die 'Could not save index tree'
353 git reset
356 eval "
357 GITHEAD_$w_tree='Stashed changes' &&
358 GITHEAD_$c_tree='Updated upstream' &&
359 GITHEAD_$b_tree='Version stash was based on' &&
360 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
363 if test -n "$GIT_QUIET"
364 then
365 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
367 if git merge-recursive $b_tree -- $c_tree $w_tree
368 then
369 # No conflict
370 if test -n "$unstashed_index_tree"
371 then
372 git read-tree "$unstashed_index_tree"
373 else
374 a="$TMP-added" &&
375 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
376 git read-tree --reset $c_tree &&
377 git update-index --add --stdin <"$a" ||
378 die "Cannot unstage modified files"
379 rm -f "$a"
381 squelch=
382 if test -n "$GIT_QUIET"
383 then
384 squelch='>/dev/null 2>&1'
386 (cd "$START_DIR" && eval "git status $squelch") || :
387 else
388 # Merge conflict; keep the exit status from merge-recursive
389 status=$?
390 if test -n "$INDEX_OPTION"
391 then
392 echo >&2 'Index was not unstashed.'
394 exit $status
398 pop_stash() {
399 assert_stash_ref "$@"
401 apply_stash "$@" &&
402 drop_stash "$@"
405 drop_stash () {
406 assert_stash_ref "$@"
408 git reflog delete --updateref --rewrite "${REV}" &&
409 say "Dropped ${REV} ($s)" || die "${REV}: Could not drop stash entry"
411 # clear_stash if we just dropped the last stash entry
412 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
415 apply_to_branch () {
416 test -n "$1" || die 'No branch name specified'
417 branch=$1
418 shift 1
420 set -- --index "$@"
421 assert_stash_like "$@"
423 git checkout -b $branch $REV^ &&
424 apply_stash "$@" && {
425 test -z "$IS_STASH_REF" || drop_stash "$@"
429 PARSE_CACHE='--not-parsed'
430 # The default command is "save" if nothing but options are given
431 seen_non_option=
432 for opt
434 case "$opt" in
435 -*) ;;
436 *) seen_non_option=t; break ;;
437 esac
438 done
440 test -n "$seen_non_option" || set "save" "$@"
442 # Main command set
443 case "$1" in
444 list)
445 shift
446 list_stash "$@"
448 show)
449 shift
450 show_stash "$@"
452 save)
453 shift
454 save_stash "$@"
456 apply)
457 shift
458 apply_stash "$@"
460 clear)
461 shift
462 clear_stash "$@"
464 create)
465 if test $# -gt 0 && test "$1" = create
466 then
467 shift
469 create_stash "$*" && echo "$w_commit"
471 drop)
472 shift
473 drop_stash "$@"
475 pop)
476 shift
477 pop_stash "$@"
479 branch)
480 shift
481 apply_to_branch "$@"
484 case $# in
486 save_stash &&
487 say '(To restore them type "git stash apply")'
490 usage
491 esac
493 esac